import * as React from 'react';
import { AnyT } from '../../definitions.interface';
import { IGenericComponentProps, IUiFactory, TranslatorT } from '../../definition';
import { ISettingsEntity } from '../../settings';
export declare class GenericComponent<TProps extends IGenericComponentProps = IGenericComponentProps, TState = {}, TSelfRef = AnyT> extends React.PureComponent<TProps, TState> {
    protected readonly selfRef: React.RefObject<TSelfRef>;
    /**
     * @stable [27.02.2020]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [18.03.2020]
     * @returns {ISettingsEntity}
     */
    protected readonly settings: ISettingsEntity;
    /**
     * @stable [18.03.2020]
     * @returns {TranslatorT}
     */
    protected readonly t: TranslatorT;
    /**
     * @stable [18.03.2020]
     * @returns {IUiFactory}
     */
    protected readonly uiFactory: IUiFactory;
}
