"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../util");
var di_1 = require("../../di");
var GenericComponent = /** @class */ (function (_super) {
    __extends(GenericComponent, _super);
    /**
     * @stable [27.02.2020]
     * @param {TProps} props
     */
    function GenericComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.selfRef = React.createRef();
        util_1.patchRenderMethod(_this);
        return _this;
    }
    Object.defineProperty(GenericComponent.prototype, "settings", {
        /**
         * @stable [18.03.2020]
         * @returns {ISettingsEntity}
         */
        get: function () {
            return di_1.getSettings();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "t", {
        /**
         * @stable [18.03.2020]
         * @returns {TranslatorT}
         */
        get: function () {
            return di_1.getTranslator();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "uiFactory", {
        /**
         * @stable [18.03.2020]
         * @returns {IUiFactory}
         */
        get: function () {
            return di_1.getUiFactory();
        },
        enumerable: true,
        configurable: true
    });
    return GenericComponent;
}(React.PureComponent));
exports.GenericComponent = GenericComponent;
//# sourceMappingURL=generic.component.js.map