import { IActionsDisabledWrapper, IEntity, IEntityWrapper, IKeyValue } from '../../definitions.interface';
import { IDictionariesWrapperEntity, IEditableEntity, IExtendedEntity, IExtendedFormEditableEntity, IListEntity, IListWrapperEntity, IPagedEntity, IPaginatedEntity, ITransportWrapperEntity, IUniversalStoreEntity, IUserWrapperEntity, ToolbarToolsEnum } from '../../definition';
import { IDataMutatorEntity } from '../../entities-definitions.interface';
export declare const dictionariesMapper: (storeEntity: IUniversalStoreEntity<{}, {}>) => IDictionariesWrapperEntity<import("core/definition/dictionary-definition.interface").IDictionariesEntity>;
export declare const transportMapper: (storeEntity: IUniversalStoreEntity<{}, {}>) => ITransportWrapperEntity<import("core/definition/transport-definition.interface").ITransportEntity>;
/**
 * @deprecated mapEditableEntity
 */
export declare const formMapper: (editableEntity: IEditableEntity<IKeyValue>) => IExtendedFormEditableEntity<IEntity>;
/**
 * @stable [16.05.2018]
 * @param {IListEntity} listEntity
 * @param {IDataMutatorEntity} dataMutator
 * @returns {IListWrapperEntity}
 */
export declare const listMapper: (listEntity: IListEntity<IEntity, any>, dataMutator?: IDataMutatorEntity<IEntity>) => IListWrapperEntity<IEntity>;
/**
 * @deprecated Use mapPagedEntity
 * @param {IPaginatedEntity} entity
 * @returns {IPaginatedEntity}
 */
export declare const listEntityPaginatedEntityMapper: (entity: IPaginatedEntity) => IPaginatedEntity;
/**
 * @deprecated Use mapListPagedEntity
 */
export declare const listEntityPageEntityFilterMapper: (listEntity: IListEntity<IEntity, any>, pageSize?: number) => IPagedEntity;
/**
 * @deprecated Use mapListWrapperPagedEntity
 */
export declare const listEntityWrapperPageEntityFilterMapper: (listEntity: IListWrapperEntity<IEntity>, pageSize?: number) => IPagedEntity;
/**
 * @stable [30.01.2019]
 * @param {IListWrapperEntity} listWrapperEntity
 * @returns {IListEntity}
 */
export declare const listSelector: (listWrapperEntity: IListWrapperEntity<IEntity>) => IListEntity<IEntity, any>;
/**
 * @deprecated Use mapListWrapperEntity
 */
export declare const listWrapperMapper: (listWrapperEntity: IListWrapperEntity<IEntity>, dataMutator?: IDataMutatorEntity<IEntity>) => IListWrapperEntity<IEntity>;
/**
 * @deprecated Use selectChanges
 */
export declare const editableEntityChangesSelector: <TResult extends IEntity = IEntity>(entity: IEditableEntity<IKeyValue>) => TResult;
/**
 * @deprecated Use mapExtendedEntity
 */
export declare const entityMapper: <TEntity extends IEntity>(entity: TEntity, editableEntity?: IEditableEntity<IKeyValue>) => IExtendedEntity<TEntity>;
/**
 * @deprecated
 */
export declare const selectedEntitySelector: <TEntity extends IEntity>(listEntity: IListEntity<IEntity, any>) => TEntity;
/**
 * @deprecated Use selectListSelectedEntity
 */
export declare const listSelectedEntitySelector: <TEntity extends IEntity>(listWrapperEntity: IListWrapperEntity<IEntity>) => TEntity;
/**
 * @deprecated Use mapListSelectedExtendedEntity
 */
export declare const listWrapperSelectedEntityMapper: <TEntity extends IEntity>(listWrapperState: IListWrapperEntity<IEntity>, formEntity?: IEditableEntity<IKeyValue>) => IEntityWrapper<TEntity>;
/**
 * @deprecated
 */
export declare const actionsDisabledListEntityMapper: (listEntity: IListEntity<IEntity, any>) => IActionsDisabledWrapper;
/**
 * @deprecated mapListWrapperActionsDisabled
 */
export declare const actionsDisabledListWrapperEntityMapper: (listWrapperEntity: IListWrapperEntity<IEntity>) => IActionsDisabledWrapper;
/**
 * @deprecated selectEditableEntityToolbarToolsActiveFilter
 */
export declare const toolbarActiveFilterToolEditableEntityMapper: (editableEntity: IEditableEntity<IKeyValue>) => ToolbarToolsEnum[];
/**
 * @deprecated selectFormEntityToolbarToolsActiveFilter
 */
export declare const toolbarActiveFilterToolFormWrapperEntityMapper: (entityFormEntity: IExtendedFormEditableEntity<IEntity>) => ToolbarToolsEnum[];
/**
 * @stable [29.05.2018]
 */
export declare const universalDefaultMappers: ((<TUser = import("core/definition/user-definition.interface").IUserEntity>(wrapper: IUserWrapperEntity<TUser>) => IUserWrapperEntity<TUser>) | ((storeEntity: IUniversalStoreEntity<{}, {}>) => IDictionariesWrapperEntity<import("core/definition/dictionary-definition.interface").IDictionariesEntity>) | ((storeEntity: IUniversalStoreEntity<{}, {}>) => ITransportWrapperEntity<import("core/definition/transport-definition.interface").ITransportEntity>))[];
