import * as React from 'react';
import { IActivateDialogConfigEntity, IDialog, IDialogProps, IDialogState } from '../../definition';
import { BaseComponent } from '../base/base.component';
export declare class BaseDialog<TProps extends IDialogProps = IDialogProps, TState extends IDialogState = IDialogState> extends BaseComponent<TProps, TState> implements IDialog<TProps, TState> {
    private onDeactivateCallback;
    private closeEventUnsubscriber;
    private readonly doesAnotherModalDialogOpen;
    private readonly bodyRef;
    /**
     * @stable [06.01.2020]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [25.01.2020]
     * @returns {React.ReactNode}
     */
    render(): React.ReactNode;
    /**
     * @stable [25.01.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [24.01.2020]
     * @param {IActivateDialogConfigEntity} payload
     */
    activate(payload?: IActivateDialogConfigEntity): void;
    /**
     * @stable [06.01.2020]
     */
    accept(): void;
    close(): void;
    /**
     * @stable [06.01.2020]
     */
    protected onAcceptClick(): void;
    /**
     * @stable [30.01.2020]
     * @returns {string}
     */
    protected readonly title: string | boolean;
    /**
     * @stable [30.01.2020]
     * @returns {string}
     */
    protected readonly closeText: string;
    /**
     * @stable [30.01.2020]
     * @returns {string}
     */
    protected readonly acceptText: string;
    /**
     * @stable [05.01.2020]
     */
    private onCloseClick;
    /**
     * @stable [05.01.2020]
     */
    private onDialogClick;
    /**
     * @stable [29.01.2020]
     */
    private onDocumentClickCapture;
    /**
     * @stable [25.01.2020]
     */
    private onAfterRender;
    /**
     * @stable [05.01.2020]
     * @param {() => void} callback
     */
    private doClose;
    /**
     * @stable [24.03.2019]
     * @returns {JSX.Element}
     */
    private readonly actionsElement;
    /**
     * @stable [16.03.2020]
     * @returns {JSX.Element}
     */
    private readonly dialogBodyElement;
    /**
     * @stable [15.03.2020]
     * @returns {JSX.Element}
     */
    private readonly titleElement;
    /**
     * @stable [15.03.2020]
     * @returns {JSX.Element}
     */
    private readonly extraActionsElement;
    /**
     * @stable [06.01.2020]
     * @returns {JSX.Element}
     */
    private readonly bodyElement;
    /**
     * @stable [25.01.2020]
     */
    private unsubscribeEvents;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly acceptable;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly closable;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly isCloseButtonDisabled;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly isAcceptButtonDisabled;
    /**
     * @stable [15.01.2020]
     * @returns {Element}
     */
    private readonly portalElement;
    /**
     * @stable [24.01.2020]
     * @returns {boolean}
     */
    private readonly isAnchored;
    /**
     * @stable [31.01.2020]
     * @returns {boolean}
     */
    private readonly isInline;
    /**
     * @stable [31.01.2020]
     * @returns {boolean}
     */
    private readonly isDefault;
    /**
     * @stable [11.03.2020]
     * @returns {boolean}
     */
    private readonly isConfirm;
    /**
     * @stable [31.01.2020]
     * @returns {boolean}
     */
    private readonly isModal;
    /**
     * @stable [16.03.2020]
     * @returns {boolean}
     */
    private readonly hasExtraActions;
    /**
     * @stable [16.03.2020]
     * @returns {boolean}
     */
    private readonly isScrollable;
    /**
     * @stable [16.03.2020]
     * @returns {GenericPluginCtorT[]}
     */
    private readonly wrapperPlugins;
    /**
     * @stable [31.01.2020]
     * @returns {string}
     */
    private readonly dialogClassName;
}
