"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var dialog_component_1 = require("../dialog.component");
var action_1 = require("../../../action");
var form_1 = require("../../form");
var util_1 = require("../../../util");
var universal_container_1 = require("../../base/universal.container");
var FilterFormDialogContainer = /** @class */ (function (_super) {
    __extends(FilterFormDialogContainer, _super);
    /**
     * @stable [10.03.2019]
     * @param {IFilterFormDialogContainerProps} props
     */
    function FilterFormDialogContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.onAcceptFilter = _this.onAcceptFilter.bind(_this);
        _this.onClearFilter = _this.onClearFilter.bind(_this);
        return _this;
    }
    /**
     * @stable [12.03.2019]
     */
    FilterFormDialogContainer.prototype.componentWillUnmount = function () {
        if (this.props.autoReset) {
            this.dispatchCustomType(action_1.FilterFormDialogActionBuilder.buildResetActionType(this.props.sectionName));
        }
    };
    /**
     * @stable [10.03.2019]
     * @returns {JSX.Element}
     */
    FilterFormDialogContainer.prototype.render = function () {
        var props = this.props;
        var _a = this.settings.messages, APPLY = _a.APPLY, CLEAR_ALL = _a.CLEAR_ALL, CLOSE = _a.CLOSE, FILTERS = _a.FILTERS;
        return (React.createElement(dialog_component_1.Dialog, { ref: props.forwardedRef, title: FILTERS, closeText: this.haveFilterChangesOrIsTouched ? CLEAR_ALL : CLOSE, acceptText: APPLY, acceptDisabled: !this.haveFilterChanges, onAccept: this.onAcceptFilter, onClose: this.onClearFilter },
            React.createElement(form_1.FormContainer, __assign({ formConfiguration: {
                    actionsRendered: false,
                    compact: true,
                } }, props))));
    };
    /**
     * @stable [10.03.2019]
     */
    FilterFormDialogContainer.prototype.onAcceptFilter = function () {
        this.dispatchCustomType(action_1.FilterFormDialogActionBuilder.buildAcceptActionType(this.props.sectionName));
    };
    /**
     * @stable [10.03.2019]
     */
    FilterFormDialogContainer.prototype.onClearFilter = function () {
        if (this.haveFilterChangesOrIsTouched) {
            this.dispatchCustomType(action_1.FilterFormDialogActionBuilder.buildClearActionType(this.props.sectionName));
        }
    };
    Object.defineProperty(FilterFormDialogContainer.prototype, "haveFilterChangesOrIsTouched", {
        /**
         * @stable [16.01.2020]
         * @returns {boolean}
         */
        get: function () {
            return this.haveFilterChanges || util_1.isTouched(this.props.form);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FilterFormDialogContainer.prototype, "haveFilterChanges", {
        /**
         * @stable [16.01.2020]
         * @returns {boolean}
         */
        get: function () {
            return !R.isEmpty(this.props.form.changes);
        },
        enumerable: true,
        configurable: true
    });
    return FilterFormDialogContainer;
}(universal_container_1.UniversalContainer));
exports.FilterFormDialogContainer = FilterFormDialogContainer;
//# sourceMappingURL=filter-form-dialog.container.js.map