"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var ts_smart_logger_1 = require("ts-smart-logger");
var text_field_1 = require("../text-field");
var util_1 = require("../../../util");
var dnd_1 = require("../../dnd");
var multifield_1 = require("../multifield");
var multifield_2 = require("../multifield");
var dialog_1 = require("../../dialog");
var web_camera_1 = require("../../web-camera");
var definition_1 = require("../../../definition");
var BaseFileField = /** @class */ (function (_super) {
    __extends(BaseFileField, _super);
    /**
     * @stable [30.10.2019]
     * @param {TProps} props
     */
    function BaseFileField(props) {
        var _this = _super.call(this, props) || this;
        _this.multiFieldPlugin = new multifield_1.MultiFieldPlugin(_this);
        _this.cameraRef = React.createRef();
        _this.cameraDialogRef = React.createRef();
        _this.dndRef = React.createRef();
        _this.doSelectBlob = _this.doSelectBlob.bind(_this);
        _this.downloadFile = _this.downloadFile.bind(_this);
        _this.onCameraDialogAccept = _this.onCameraDialogAccept.bind(_this);
        _this.onCameraDialogClose = _this.onCameraDialogClose.bind(_this);
        _this.onCameraSnapshotSelect = _this.onCameraSnapshotSelect.bind(_this);
        _this.onSelect = _this.onSelect.bind(_this);
        _this.openCameraDialog = _this.openCameraDialog.bind(_this);
        _this.openFileDialog = _this.openFileDialog.bind(_this);
        var actions = util_1.objectValuesArrayFilter(props.useCamera && { type: definition_1.FieldActionTypesEnum.VIDEO, onClick: _this.openCameraDialog }, { type: definition_1.FieldActionTypesEnum.ATTACH_FILE, onClick: _this.openFileDialog }, props.useDownloadAction && {
            type: definition_1.FieldActionTypesEnum.DOWNLOAD,
            disabled: function () { return _this.isDownloadActionDisabled; },
            onClick: _this.downloadFile,
        });
        _this.defaultActions = actions.concat(_this.defaultActions);
        return _this;
    }
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    BaseFileField.prototype.onKeyEnter = function (event) {
        _super.prototype.onKeyEnter.call(this, event);
        this.openFileDialog(event);
    };
    /**
     * @stable [28.06.2018]
     * @param {IKeyboardEvent} event
     */
    BaseFileField.prototype.onKeyBackspace = function (event) {
        _super.prototype.onKeyBackspace.call(this, event);
        this.clearValue();
    };
    BaseFileField.prototype.clearValue = function () {
        var activeValue = this.multiFieldPlugin.activeValue[0];
        if (!R.isNil(activeValue)) {
            var currentValue = activeValue.id;
            this.databaseStorage.remove(currentValue);
            this.multiFieldPlugin.onDeleteItem({ id: currentValue });
        }
    };
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    BaseFileField.prototype.onClick = function (event) {
        _super.prototype.onClick.call(this, event);
        this.openFileDialog(event);
    };
    /**
     * @stable [03.08.2018]
     * @returns {JSX.Element}
     */
    BaseFileField.prototype.getAttachmentElement = function () {
        var _this = this;
        var state = this.state;
        var props = this.props;
        var messages = this.settings.messages;
        var dndElement = (React.createElement(dnd_1.DnD, { ref: this.dndRef, disabled: this.isInactive, onSelect: this.onSelect }));
        if (!props.useCamera) {
            return dndElement;
        }
        return (React.createElement("div", { className: 'rac-dnd-wrapper' },
            dndElement,
            util_1.orNull(this.state.opened, function () { return (React.createElement(dialog_1.Dialog, { ref: _this.cameraDialogRef, title: messages.takeSnapshotMessage, acceptText: messages.acceptMessage, onClose: _this.onCameraDialogClose, onBeforeAccept: _this.onCameraDialogAccept },
                React.createElement(web_camera_1.WebCamera, { ref: _this.cameraRef, onSelect: _this.onCameraSnapshotSelect }))); })));
    };
    Object.defineProperty(BaseFileField.prototype, "originalEmptyValue", {
        /**
         * @stable [02.08.2018]
         * @returns {EntityIdT[]}
         */
        get: function () {
            return [];
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [05.10.2018]
     * @returns {string}
     */
    BaseFileField.prototype.getFieldClassName = function () {
        return util_1.joinClassName(_super.prototype.getFieldClassName.call(this), 'rac-filefield');
    };
    /**
     * @stable [14.01.2019]
     * @param {AnyT} value
     * @returns {string}
     */
    BaseFileField.prototype.decorateDisplayValue = function (value) {
        var len = this.multiFieldPlugin.getActiveValueLength(value);
        return this.buildDisplayMessage(len > 0, len);
    };
    /**
     * @stable [02.08.2018]
     */
    BaseFileField.prototype.onCameraDialogClose = function () {
        this.setState({ opened: false });
    };
    /**
     * @stable [02.08.2018]
     */
    BaseFileField.prototype.onCameraDialogAccept = function () {
        this.camera.capture();
        this.onCameraDialogClose();
    };
    /**
     * @stable [19.12.2018]
     * @param {Blob[]} file
     */
    BaseFileField.prototype.onSelect = function (file) {
        if (!this.props.multi) {
            this.clearValue();
        }
        this.doSelectBlob(file[0]);
    };
    /**
     * @stable [02.08.2018]
     * @param {Blob} blob
     */
    BaseFileField.prototype.doSelectBlob = function (blob) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = util_1.uuid();
                        return [4 /*yield*/, this.databaseStorage.set(url, blob)];
                    case 1:
                        _a.sent();
                        this.multiFieldPlugin.onAddItem({ id: url });
                        this.setFocus();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [01.08.2019]
     * @param {Blob} blob
     */
    BaseFileField.prototype.onCameraSnapshotSelect = function (blob) {
        this.onSelect([blob]);
    };
    Object.defineProperty(BaseFileField.prototype, "dnd", {
        get: function () {
            return this.dndRef.current;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [02.08.2018]
     * @param {IBaseEvent} event
     */
    BaseFileField.prototype.openCameraDialog = function (event) {
        var _this = this;
        this.setState({ opened: true }, function () { return _this.cameraDialog.activate(); });
    };
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    BaseFileField.prototype.openFileDialog = function (event) {
        this.dnd.open();
    };
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    BaseFileField.prototype.downloadFile = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var url, fileName, blob;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isValueNotPresent) {
                            return [2 /*return*/];
                        }
                        url = multifield_2.toLastAddedMultiItemEntityId(this.value);
                        fileName = this.props.fileName || url;
                        return [4 /*yield*/, this.databaseStorage.get(url)];
                    case 1:
                        blob = _a.sent();
                        return [2 /*return*/, R.isNil(blob) ? util_1.downloadFile(url, fileName) : util_1.downloadFileAsBlob(blob, fileName)];
                }
            });
        });
    };
    Object.defineProperty(BaseFileField.prototype, "cameraDialog", {
        /**
         * @stable [15.02.2020]
         * @returns {Dialog}
         */
        get: function () {
            return this.cameraDialogRef.current;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseFileField.prototype, "camera", {
        /**
         * @stable [14.02.2020]
         * @returns {WebCamera}
         */
        get: function () {
            return this.cameraRef.current;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseFileField.prototype, "isDownloadActionDisabled", {
        /**
         * @stable [30.10.2019]
         * @returns {boolean}
         */
        get: function () {
            return this.isDisabled || this.isFieldBusy() || this.isValueNotPresent;
        },
        enumerable: true,
        configurable: true
    });
    BaseFileField.logger = ts_smart_logger_1.LoggerFactory.makeLogger('BaseFileField');
    return BaseFileField;
}(text_field_1.BaseTextField));
exports.BaseFileField = BaseFileField;
//# sourceMappingURL=base-filefield.component.js.map