/// <reference types="react" />
import { BaseSelect } from '../select/base-select.component';
import { IMenuProps, IPlaceEntity, IPlaceFieldProps, IPlaceFieldState, IPlaceSelectOptionEntity } from '../../../definition';
export declare class PlaceField extends BaseSelect<IPlaceFieldProps, IPlaceFieldState> {
    static readonly defaultProps: IPlaceFieldProps;
    private static readonly PLACE_MARKER;
    private readonly dialogRef;
    private readonly googleMapsRef;
    private readonly googleMapsMenuOptions;
    private placeGeoCodeTask;
    /**
     * @stable [09.01.2020]
     * @param {IPlaceFieldProps} props
     */
    constructor(props: IPlaceFieldProps);
    /**
     * @stable [09.01.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [11.01.2020]
     * @param {IPlaceSelectOptionEntity} option
     */
    protected onSelect(option: IPlaceSelectOptionEntity): void;
    /**
     * @stable [11.01.2020]
     * @param {IPlaceEntity | string} value
     * @returns {string}
     */
    protected decorateDisplayValue(value: IPlaceEntity | string): string;
    /**
     * @stable [09.01.2020]
     * @returns {JSX.Element}
     */
    protected getAttachmentElement(): JSX.Element;
    /**
     * @stable [09.01.2020]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [09.01.2020]
     * @returns {IMenuProps}
     */
    protected getMenuProps(): IMenuProps;
    /**
     * @stable [11.01.2020]
     * @param {IPlaceGeoCodeRequestEntity} geoCodeRequest
     * @param {IPlaceSelectOptionEntity} option
     */
    private refreshGeocodeInfo;
    /**
     * @stable [11.01.2020]
     * @param {IPlaceEntity[]} result
     * @param {IPlaceSelectOptionEntity} option
     */
    private onGeoCodeRequestDone;
    /**
     * @stable [29.01.2020]
     * @param {IPlaceEntity} placeEntity
     * @param {IPlaceSelectOptionEntity} option
     */
    private doSelect;
    /**
     * @stable [09.01.2020]
     * @param {IGoogleMapsMenuItemEntity} payload
     */
    private onDialogMenuActionSelect;
    /**
     * @stable [11.01.2020]
     */
    private onDialogAccept;
    /**
     * @stable [09.01.2020]
     */
    private onDialogDeactivate;
    /**
     * @stable [09.01.2020]
     */
    private openDialog;
    /**
     * @stable [09.01.2020]
     */
    private cancelPlaceGeoCodeTask;
    /**
     * @stable [09.01.2020]
     */
    private initPlaceMarker;
    /**
     * @stable [10.01.2020]
     * @param {IPlaceEntity | string} placeEntity
     * @returns {string}
     */
    private placeEntityAsDisplayValue;
    /**
     * @stable [28.01.2020]
     * @param {IPlaceEntity | string} placeEntity
     * @returns {string}
     */
    private zipCodeEntityAsDisplayValue;
    /**
     * @stable [09.01.2020]
     * @returns {boolean}
     */
    private readonly isPlaceChanged;
    /**
     * @stable [09.01.2020]
     * @returns {IDialog}
     */
    private readonly dialog;
    /**
     * @stable [09.01.2020]
     * @returns {IGoogleMaps}
     */
    private readonly googleMaps;
    /**
     * @stable [11.01.2020]
     * @returns {boolean}
     */
    private readonly useZipCode;
}
