/// <reference types="react" />
import { IApiEntity, IFormProps } from '../../definition';
import { BaseComponent } from '../base';
export declare class Form extends BaseComponent<IFormProps> {
    private readonly fieldsPresets;
    /**
     * @stable [29.05.2018]
     * @param {IFormProps} props
     */
    constructor(props: IFormProps);
    /**
     * @stable [30.01.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [30.01.2020]
     */
    componentDidMount(): void;
    /**
     * @stable [30.01.2020]
     */
    submit(): void;
    /**
     * @stable [30.01.2020]
     * @returns {IApiEntity}
     */
    readonly apiEntity: IApiEntity;
    /**
     * @stable [30.01.2020]
     * @returns {HTMLFormElement}
     */
    getSelf(): HTMLFormElement;
    /**
     * @stable [13.02.2020]
     * @returns {string}
     */
    private readonly formClassName;
    /**
     * @stable [03.02.2020]
     * @param {string} name
     * @param {AnyT} value
     */
    private onChange;
    /**
     * @stable [03.02.2020]
     * @param {IField} field
     */
    private onFieldEmptyDictionary;
    private onLoadDictionary;
    /**
     * @stable [03.02.2020]
     */
    private propsOnValid;
    /**
     * @stable [30.01.2020]
     */
    private doSubmit;
    /**
     * @stable [03.02.2020]
     * @param {IBaseEvent} event
     */
    private onSubmit;
    /**
     * @stable [30.01.2020]
     * @param {IBaseEvent} event
     */
    private onReset;
    /**
     * @stable [30.01.2020]
     * @returns {boolean}
     */
    private readonly isFormValid;
    /**
     * @stable [23.03.2020]
     * @returns {boolean}
     */
    private readonly isFormSubmittable;
    /**
     * @stable [23.03.2020]
     * @returns {boolean}
     */
    private readonly isFormResettable;
    /**
     * @stable [03.02.2020]
     * @returns {boolean}
     */
    private readonly isFormOfNewEntity;
    /**
     * @stable [25.09.2019]
     * @returns {boolean}
     */
    private readonly isFormBusy;
    /**
     * @stable [25.09.2019]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldReadOnly;
    /**
     * @stable [23.03.2020]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldDisabled;
    /**
     * @stable [23.03.2020]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldChangeable;
    /**
     * @stable [16.11.2019]
     * @param {IField} field
     * @returns {AnyT}
     */
    private getFieldValue;
    /**
     * @stable [16.11.2019]
     * @param {IField} field
     * @returns {AnyT}
     */
    private getFieldOriginalValue;
    /**
     * @stable [24.12.2019]
     * @param {IFieldProps} props
     * @param {IFieldProps} defaultProps
     * @returns {AnyT}
     */
    private getFieldDisplayValue;
    /**
     * @stable [03.02.2020]
     * @param {IField} field
     * @returns {IFieldProps}
     */
    private getPredefinedFieldProps;
    /**
     * @stable [13.02.2020]
     * @returns {JSX.Element}
     */
    private readonly formActionsElement;
    /**
     * @stable [03.02.2020]
     * @returns {React.ReactNode[]}
     */
    private readonly formNodes;
    /**
     * @stable [03.02.2020]
     * @returns {boolean}
     */
    private readonly hasError;
    /**
     * @stable [03.02.2020]
     * @returns {IEditableEntity<IEntity>}
     */
    private readonly form;
    /**
     * @stable [13.02.2020]
     * @returns {IButtonProps[]}
     */
    private readonly actions;
}
