"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var base_1 = require("../base");
var form_1 = require("../form");
var FormContainer = /** @class */ (function (_super) {
    __extends(FormContainer, _super);
    /**
     * @stable [03.02.2020]
     * @param {IFormContainerProps} props
     */
    function FormContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.onChange = _this.onChange.bind(_this);
        _this.onEmptyDictionary = _this.onEmptyDictionary.bind(_this);
        _this.onLoadDictionary = _this.onLoadDictionary.bind(_this);
        _this.onReset = _this.onReset.bind(_this);
        _this.onSubmit = _this.onSubmit.bind(_this);
        _this.onValid = _this.onValid.bind(_this);
        return _this;
    }
    /**
     * @stable [03.02.2020]
     * @returns {JSX.Element}
     */
    FormContainer.prototype.render = function () {
        var props = this.props;
        return (React.createElement(form_1.Form, __assign({ form: props.form, entity: props.entity, originalEntity: props.originalEntity, onChange: this.onChange, onSubmit: this.onSubmit, onBeforeSubmit: props.onBeforeSubmit, onReset: this.onReset, onValid: this.onValid, onEmptyDictionary: this.onEmptyDictionary, onLoadDictionary: this.onLoadDictionary }, props.formConfiguration), props.children));
    };
    /**
     * @stable [17.02.2019]
     * @param {IFieldChangeEntity} payload
     */
    FormContainer.prototype.onChange = function (payload) {
        if (payload.name) {
            this.formStoreProxy.dispatchFormChange(payload);
        }
    };
    /**
     * @stable [03.02.2020]
     * @param {boolean} valid
     */
    FormContainer.prototype.onValid = function (valid) {
        this.formStoreProxy.dispatchFormValid(valid);
    };
    /**
     * @stable [03.02.2020]
     */
    FormContainer.prototype.onReset = function () {
        this.formStoreProxy.dispatchFormReset();
    };
    /**
     * @stable [02.04.2019]
     * @param {IApiEntity} apiEntity
     */
    FormContainer.prototype.onSubmit = function (apiEntity) {
        this.formStoreProxy.dispatchFormSubmit(apiEntity);
    };
    FormContainer.prototype.onEmptyDictionary = function (dictionary, apiEntity) {
        this.dispatchLoadDictionary(dictionary, apiEntity);
    };
    FormContainer.prototype.onLoadDictionary = function (items) {
        var noAvailableItemsToSelect = this.settings.messages.noAvailableItemsToSelectMessage;
        if (noAvailableItemsToSelect && R.isEmpty(items)) {
            this.dispatchNotification(noAvailableItemsToSelect);
        }
    };
    return FormContainer;
}(base_1.BasicContainer));
exports.FormContainer = FormContainer;
//# sourceMappingURL=form.container.js.map