"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../util");
var definition_1 = require("../../definition");
var generic_component_1 = require("../base/generic.component");
var Info = /** @class */ (function (_super) {
    __extends(Info, _super);
    function Info() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [23.04.2018]
     * @returns {JSX.Element}
     */
    Info.prototype.render = function () {
        var props = this.props;
        var error = props.error, message = props.message, progress = props.progress;
        var messages = this.settings.messages;
        var result = progress === true
            ? { text: messages.PLEASE_WAIT, progress: true }
            : (util_1.isStringNotEmpty(progress)
                ? { text: this.t(progress), progress: true }
                : (error === true
                    ? { text: messages.ERROR, error: true }
                    : (util_1.isStringNotEmpty(error)
                        ? { text: this.t(error), error: true }
                        : (error instanceof Error
                            ? { text: (error.stack), error: true }
                            : (util_1.isObject(error)
                                ? { text: util_1.formatJson(error), error: true }
                                : { text: message })))));
        return (React.createElement("div", { className: util_1.joinClassName(definition_1.InfoClassesEnum.INFO, util_1.isFull(props) && definition_1.InfoClassesEnum.FULL_INFO, result.error && definition_1.InfoClassesEnum.ERROR_INFO, result.progress && definition_1.InfoClassesEnum.PROGRESS_INFO, !result.error && !result.progress && definition_1.InfoClassesEnum.MESSAGE_INFO, util_1.calc(props.className)) },
            result.text && (React.createElement("span", { className: definition_1.InfoClassesEnum.INFO_TEXT },
                result.progress && this.uiFactory.makeIcon({ type: definition_1.IconsEnum.SPINNER, className: definition_1.InfoClassesEnum.INFO_ICON }),
                result.text)),
            props.children));
    };
    return Info;
}(generic_component_1.GenericComponent));
exports.Info = Info;
//# sourceMappingURL=info.component.js.map