/// <reference types="react" />
import { BaseComponent } from '../../base/base.component';
import { IDefaultLayoutProps } from '../../../definition';
export declare class DefaultLayout extends BaseComponent<IDefaultLayoutProps> {
    /**
     * @stable [04.02.2020]
     * @param {IDefaultLayoutProps} props
     */
    constructor(props: IDefaultLayoutProps);
    /**
     * @stable [05.02.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [28.03.2020]
     * @returns {JSX.Element}
     */
    private readonly headerElement;
    /**
     * @stable [04.02.2020]
     * @returns {JSX.Element}
     */
    private readonly drawerElement;
    /**
     * @stable [04.02.2020]
     * @returns {JSX.Element}
     */
    private readonly drawerHeaderElement;
    private readonly drawerContentElement;
    private onLogoMenuActionClick;
    private onDrawerHeaderLogoClick;
    /**
     * @stable [04.02.2020]
     * @returns {boolean}
     */
    private readonly isLayoutFullModeEnabled;
    /**
     * @stable [28.03.2020]
     * @returns {LayoutModesEnum}
     */
    private readonly layoutMode;
    /**
     * @stable [28.03.2020]
     * @returns {boolean}
     */
    private readonly isDrawerHeaderRendered;
    /**
     * @stable [13.02.2020]
     * @returns {boolean}
     */
    private readonly isHeaderBackActionRendered;
    /**
     * @stable [28.03.2020]
     * @returns {IDefaultLayoutProps}
     */
    private readonly mergedProps;
    /**
     * @stable [28.03.2020]
     * @returns {IHeaderProps}
     */
    private readonly mergedHeaderProps;
}
