"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_component_1 = require("../../base/base.component");
var util_1 = require("../../../util");
var drawer_1 = require("../../drawer");
var definition_1 = require("../../../definition");
var flex_1 = require("../../layout/flex");
var plugin_1 = require("../../plugin");
var header_1 = require("../../header");
var main_1 = require("../../main");
var DefaultLayout = /** @class */ (function (_super) {
    __extends(DefaultLayout, _super);
    /**
     * @stable [04.02.2020]
     * @param {IDefaultLayoutProps} props
     */
    function DefaultLayout(props) {
        var _this = _super.call(this, props) || this;
        _this.onDrawerHeaderLogoClick = _this.onDrawerHeaderLogoClick.bind(_this);
        _this.onLogoMenuActionClick = _this.onLogoMenuActionClick.bind(_this);
        return _this;
    }
    /**
     * @stable [05.02.2020]
     * @returns {JSX.Element}
     */
    DefaultLayout.prototype.render = function () {
        var props = this.props;
        var stickyMarker = definition_1.ElementsMarkersEnum.STICKY_ELEMENT_275B4646;
        var selectedMarker = definition_1.ElementsMarkersEnum.SELECTED_ELEMENT_817ACCF6;
        return (React.createElement(definition_1.UniversalStickyContext.Provider, { value: stickyMarker },
            React.createElement(definition_1.UniversalScrollableContext.Provider, { value: selectedMarker },
                React.createElement("div", { className: util_1.joinClassName('rac-default-layout', util_1.calc(props.className), util_1.isSubHeaderRendered(props) ? 'rac-default-layout-with-sub-header' : 'rac-default-layout-without-sub-header', this.isLayoutFullModeEnabled ? 'rac-default-layout-full' : 'rac-default-layout-mini') },
                    this.drawerElement,
                    React.createElement("div", { className: 'rac-default-layout__body' },
                        util_1.isHeaderRendered(props) && (props.header || this.headerElement),
                        React.createElement(main_1.Main, { stickyElementClassName: stickyMarker, selectedElementClassName: selectedMarker, plugins: [
                                plugin_1.PerfectScrollPlugin,
                                plugin_1.SelectedElementPlugin,
                                plugin_1.StickyHeaderPlugin
                            ] }, props.children),
                        props.footer)))));
    };
    Object.defineProperty(DefaultLayout.prototype, "headerElement", {
        /**
         * @stable [28.03.2020]
         * @returns {JSX.Element}
         */
        get: function () {
            var props = this.props;
            return (React.createElement(header_1.Header, __assign({}, props.headerConfiguration, util_1.mapStoreEntity(props), { backActionRendered: this.isHeaderBackActionRendered && (util_1.selectStackWrapperItemEntities(this.props) || []).length > 1 })));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "drawerElement", {
        /**
         * @stable [04.02.2020]
         * @returns {JSX.Element}
         */
        get: function () {
            var isLayoutFullModeEnabled = this.isLayoutFullModeEnabled;
            return (React.createElement(drawer_1.Drawer, { mini: !isLayoutFullModeEnabled },
                this.isDrawerHeaderRendered && this.drawerHeaderElement,
                this.props.navigationListElement));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "drawerHeaderElement", {
        /**
         * @stable [04.02.2020]
         * @returns {JSX.Element}
         */
        get: function () {
            return (React.createElement("div", { className: 'rac-default-layout__drawer-header', onClick: this.onLogoMenuActionClick }, this.drawerContentElement));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "drawerContentElement", {
        get: function () {
            var appVersion = this.environment.appVersion;
            var isLayoutFullModeEnabled = this.isLayoutFullModeEnabled;
            return (React.createElement(flex_1.FlexLayout, { row: true, alignItemsCenter: true, className: 'rac-profile' },
                appVersion && React.createElement("div", { className: 'rac-profile-app-version' }, appVersion),
                isLayoutFullModeEnabled && React.createElement("div", { className: 'rac-profile-avatar' }),
                this.uiFactory.makeIcon({
                    key: 'drawer-menu-logo-lkey',
                    type: 'menu',
                    className: 'rac-logo-menu-icon',
                    onClick: this.onDrawerHeaderLogoClick,
                })));
        },
        enumerable: true,
        configurable: true
    });
    DefaultLayout.prototype.onLogoMenuActionClick = function () {
        this.props.onLogoMenuActionClick();
    };
    DefaultLayout.prototype.onDrawerHeaderLogoClick = function () {
        this.props.onDrawerHeaderClick(this.layoutMode);
    };
    Object.defineProperty(DefaultLayout.prototype, "isLayoutFullModeEnabled", {
        /**
         * @stable [04.02.2020]
         * @returns {boolean}
         */
        get: function () {
            return this.layoutMode === definition_1.LayoutModesEnum.FULL;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "layoutMode", {
        /**
         * @stable [28.03.2020]
         * @returns {LayoutModesEnum}
         */
        get: function () {
            return util_1.nvl(this.mergedProps.layoutMode, this.props.layout.mode);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "isDrawerHeaderRendered", {
        /**
         * @stable [28.03.2020]
         * @returns {boolean}
         */
        get: function () {
            return util_1.isDrawerHeaderRendered(this.mergedProps);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "isHeaderBackActionRendered", {
        /**
         * @stable [13.02.2020]
         * @returns {boolean}
         */
        get: function () {
            return util_1.isBackActionRendered(this.mergedHeaderProps);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "mergedProps", {
        /**
         * @stable [28.03.2020]
         * @returns {IDefaultLayoutProps}
         */
        get: function () {
            return util_1.mergeWithSystemProps(this.props, this.settings.components.defaultLayout);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayout.prototype, "mergedHeaderProps", {
        /**
         * @stable [28.03.2020]
         * @returns {IHeaderProps}
         */
        get: function () {
            return util_1.mergeWithSystemProps(this.props.headerConfiguration, this.settings.components.header);
        },
        enumerable: true,
        configurable: true
    });
    return DefaultLayout;
}(base_component_1.BaseComponent));
exports.DefaultLayout = DefaultLayout;
//# sourceMappingURL=default-layout.component.js.map