"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var list_1 = require("../../list");
var di_1 = require("../../../di");
var util_1 = require("../../../util");
var basic_container_1 = require("../../base/basic.container");
var header_1 = require("../../header");
var navigation_1 = require("../../../navigation");
var flex_1 = require("../flex");
var operation_1 = require("../../../operation");
var layout_interface_1 = require("../layout.interface");
var definition_1 = require("../../../definition");
var overlay_1 = require("../../overlay");
var plugin_1 = require("../../plugin");
var default_layout_component_1 = require("./default-layout.component");
var notification_1 = require("../../notification");
var DefaultLayoutContainer = /** @class */ (function (_super) {
    __extends(DefaultLayoutContainer, _super);
    /**
     * @stable [18.09.2018]
     * @param {IDefaultLayoutContainerProps} props
     */
    function DefaultLayoutContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.onDrawerHeaderClick = _this.onDrawerHeaderClick.bind(_this);
        _this.onHeaderMenuSelectItem = _this.onHeaderMenuSelectItem.bind(_this);
        _this.onHeaderMoreOptionsSelect = _this.onHeaderMoreOptionsSelect.bind(_this);
        _this.onHeaderNavigationActionClick = _this.onHeaderNavigationActionClick.bind(_this);
        _this.onLogoMenuActionClick = _this.onLogoMenuActionClick.bind(_this);
        _this.onNavigationListClick = _this.onNavigationListClick.bind(_this);
        _this.onNavigationListGroupClick = _this.onNavigationListGroupClick.bind(_this);
        _this.onNavigationListScroll = _this.onNavigationListScroll.bind(_this);
        _this.state = { notifications: false };
        return _this;
    }
    DefaultLayoutContainer.prototype.render = function () {
        var props = this.props;
        return (React.createElement(notification_1.NotificationContainer, __assign({}, props),
            React.createElement(default_layout_component_1.DefaultLayout, __assign({}, props, { headerConfiguration: __assign({ onSelect: this.onHeaderMenuSelectItem, backActionConfiguration: { onClick: this.routerStoreProxy.navigateBack } }, props.headerConfiguration), onLogoMenuActionClick: this.onLogoMenuActionClick, onDrawerHeaderClick: this.onDrawerHeaderClick, navigationListElement: this.navigationListElement }), this.mainElement)));
    };
    /**
     * @stable [06.02.2020]
     * @param {IMenuItemEntity} item
     */
    DefaultLayoutContainer.prototype.onHeaderMenuSelectItem = function (item) {
        switch (item.value) {
            case definition_1.HeaderUserMenuActionsEnum.EXIT:
                this.routerStoreProxy.navigate(this.routes.logout);
                break;
            case definition_1.HeaderUserMenuActionsEnum.PROFILE:
                this.routerStoreProxy.navigate(this.routes.profile);
                break;
        }
    };
    /**
     * @stable [18.09.2018]
     * @param {IMenuItemStringValueEntity} option
     */
    DefaultLayoutContainer.prototype.onHeaderMoreOptionsSelect = function (option) {
        var params = { payload: operation_1.Operation.create(option.value) };
        this.dispatchFrameworkAction(option.value, params);
    };
    /**
     * @stable [17.10.2018]
     */
    DefaultLayoutContainer.prototype.onLogoMenuActionClick = function () {
        this.navigate(this.routes.home);
    };
    /**
     * @stable [18.09.2018]
     */
    DefaultLayoutContainer.prototype.onHeaderNavigationActionClick = function () {
        var props = this.props;
        var headerConfiguration = props.subHeaderConfiguration;
        if (util_1.isFn(headerConfiguration.onNavigationActionClick)) {
            headerConfiguration.onNavigationActionClick();
        }
    };
    /**
     * @stable [23.12.2019]
     * @param {IXYEntity} xy
     */
    DefaultLayoutContainer.prototype.onNavigationListScroll = function (xy) {
        this.dispatchCustomType(layout_interface_1.LAYOUT_XY_UPDATE_ACTION_TYPE, { payload: xy });
    };
    Object.defineProperty(DefaultLayoutContainer.prototype, "menuItems", {
        /**
         * @stable [18.09.2018]
         * @returns {INavigationListItemEntity[]}
         */
        get: function () {
            return this.navigationMenuBuilder.provide(this.props);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [04.12.2019]
     */
    DefaultLayoutContainer.prototype.onDrawerHeaderClick = function (layoutMode) {
        this.dispatchCustomType(layout_interface_1.LAYOUT_MODE_UPDATE_ACTION_TYPE, { payload: layoutMode });
    };
    Object.defineProperty(DefaultLayoutContainer.prototype, "mainElement", {
        /**
         * @stable [08.10.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var props = this.props;
            return (React.createElement(React.Fragment, null,
                props.subHeaderRendered !== false && this.subHeaderElement,
                this.props.children,
                this.mainProgressOverlayElement,
                this.notificationsElement));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "subHeaderElement", {
        get: function () {
            var props = this.props;
            var activeItem = this.menuItems.find(function (item) { return item.active; });
            var title = props.title || (activeItem && activeItem.label);
            return (React.createElement(header_1.SubHeader, __assign({}, props.subHeaderConfiguration, { title: title, onNavigationActionClick: this.onHeaderNavigationActionClick, onMoreOptionsSelect: this.onHeaderMoreOptionsSelect })));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "mainProgressOverlayElement", {
        /**
         * @stable [18.03.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            return util_1.orNull(this.props.progress, function () { return React.createElement(overlay_1.Overlay, { progress: true }); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "notificationsElement", {
        /**
         * @stable [11.02.2019]
         * @returns {JSX.Element}
         */
        get: function () {
            return util_1.orNull(this.state.notifications, function () { return (React.createElement(flex_1.FlexLayout, { className: 'rac-notifications' }, "3 new notifications")); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultLayoutContainer.prototype, "navigationListElement", {
        get: function () {
            return (React.createElement(list_1.NavigationList, __assign({}, this.props.layout, { dividerRendered: false, items: this.menuItems, onScroll: this.onNavigationListScroll, onClick: this.onNavigationListClick, onGroupClick: this.onNavigationListGroupClick, plugins: [plugin_1.PersistentScrollPlugin, plugin_1.PerfectScrollPlugin] })));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [24.03.2020]
     * @param {INavigationListItemEntity} item
     */
    DefaultLayoutContainer.prototype.onNavigationListClick = function (item) {
        var _this = this;
        util_1.ifNotEmptyThanValue(item.link, function (link) { return _this.routerStoreProxy.navigate(link); });
    };
    DefaultLayoutContainer.prototype.onNavigationListGroupClick = function (item) {
        var itemValue = item.value;
        if (R.isNil(itemValue)) {
            return;
        }
        var payloadWrapper = { payload: itemValue };
        this.dispatchCustomType(layout_interface_1.LAYOUT_EXPANDED_GROUPS_UPDATE_ACTION_TYPE, payloadWrapper);
    };
    DefaultLayoutContainer.defaultProps = {
        subHeaderConfiguration: {},
    };
    __decorate([
        di_1.lazyInject(navigation_1.NavigationMenuBuilder),
        __metadata("design:type", navigation_1.NavigationMenuBuilder)
    ], DefaultLayoutContainer.prototype, "navigationMenuBuilder", void 0);
    return DefaultLayoutContainer;
}(basic_container_1.BasicContainer));
exports.DefaultLayoutContainer = DefaultLayoutContainer;
//# sourceMappingURL=default-layout.container.js.map