/// <reference types="react" />
import { INavigationListProps, INavigationListState } from '../../../definition';
import { BaseComponent } from '../../base/base.component';
export declare class NavigationList extends BaseComponent<INavigationListProps, INavigationListState> {
    private readonly menuRef;
    private readonly itemsRefsMap;
    /**
     * @stable [23.03.2020]
     * @param {INavigationListProps} props
     */
    constructor(props: INavigationListProps);
    /**
     * @stable [24.10.2019]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [23.03.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [07.02.2020]
     * @param {string} key
     * @returns {JSX.Element}
     */
    private getListDividerElement;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemEntity} item
     * @returns {JSX.Element}
     */
    private toElement;
    /**
     * @stable [12.02.2020]
     * @param {INavigationListItemEntity} item
     * @returns {JSX.Element}
     */
    private asItemElement;
    /**
     * @stable [23.03.2020]
     * @param {IMenuItemEntity<INavigationListItemEntity>} option
     */
    private onPopupMenuItemSelect;
    /**
     * @stable [24.03.2020]
     * @param {INavigationListItemEntity} entity
     */
    private onGroupClick;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemEntity} item
     * @returns {boolean}
     */
    private isItemExpanded;
    /**
     * @stable [23.09.2018]
     * @returns {boolean}
     */
    private readonly isFullLayoutModeEnabled;
    private readonly layoutMode;
    /**
     * @stable [04.02.2020]
     * @returns {LayoutModesEnum}
     */
    private readonly systemLayoutMode;
    /**
     * @stable [04.02.2020]
     * @returns {IDefaultLayoutProps}
     */
    private readonly systemSettings;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemEntity} item
     * @returns {boolean}
     */
    private hasActiveChild;
    /**
     * @stable [24.03.2020]
     * @param {INavigationListItemEntity} item
     * @param {INavigationListItemEntity} activeGroup
     * @returns {INavigationListItemEntity}
     */
    private asPopupMenuItem;
    /**
     * @stable [24.03.2020]
     * @returns {HTMLElement}
     */
    private asPopupMenuAnchorElement;
    /**
     * @stable [23.03.2020]
     * @param {boolean} isGroup
     * @param {boolean} isActive
     * @param {boolean} isExpanded
     * @returns {string}
     */
    private asItemClasses;
    /**
     * @stable [23.03.2020]
     * @param {string} link
     * @param {string} prefix
     * @returns {string}
     */
    private asUniqueKey;
}
