import * as React from 'react';
import { IconDefinition } from '@fortawesome/free-solid-svg-icons';
import { IUIFactory } from '../../factory';
import { IUIIconConfiguration } from '../../../configurations-definitions.interface';
import { IconsEnum, IUniversalUiMessageConfigEntity } from '../../../definition';
export declare class UIMaterialFactory implements IUIFactory {
    static ICONS_MAP: {
        [IconsEnum.SEARCH_MINUS]: IconDefinition;
        [IconsEnum.SEARCH_PLUS]: IconDefinition;
        [IconsEnum.SIGN_OUT_ALT]: IconDefinition;
        access_time: IconDefinition;
        add: IconDefinition;
        address_card: IconDefinition;
        adversal: IconDefinition;
        angle_double_right: IconDefinition;
        angle_left: IconDefinition;
        angle_right: IconDefinition;
        arrow_alt_circle_down: IconDefinition;
        arrow_alt_circle_right_regular: IconDefinition;
        arrow_alt_circle_up_regular: IconDefinition;
        arrow_down: IconDefinition;
        arrow_left: IconDefinition;
        arrow_right: IconDefinition;
        arrow_up: IconDefinition;
        attach_file: IconDefinition;
        attention: IconDefinition;
        barcode: IconDefinition;
        binoculars: IconDefinition;
        card_giftcard: IconDefinition;
        category: IconDefinition;
        chart_pie: IconDefinition;
        check: IconDefinition;
        check_circle: IconDefinition;
        circle_regular: IconDefinition;
        clear_all: IconDefinition;
        cloud: IconDefinition;
        comments_regular: IconDefinition;
        contact_mail: IconDefinition;
        contact_phone: IconDefinition;
        dashboard: IconDefinition;
        done: IconDefinition;
        done_all: IconDefinition;
        error: IconDefinition;
        exchange: IconDefinition;
        exchange_alt: IconDefinition;
        exclamation: IconDefinition;
        exclamation_circle: IconDefinition;
        exclamation_triangle: IconDefinition;
        eye: IconDefinition;
        fa_heart_regular: IconDefinition;
        file: IconDefinition;
        file_import: IconDefinition;
        file_invoice_dollar: IconDefinition;
        first_page: IconDefinition;
        gift: IconDefinition;
        grip_horizontal: IconDefinition;
        group: IconDefinition;
        hdd: IconDefinition;
        history: IconDefinition;
        home: IconDefinition;
        houzz: IconDefinition;
        http: IconDefinition;
        id_card: IconDefinition;
        info: IconDefinition;
        key: IconDefinition;
        local_atm: IconDefinition;
        local_offer: IconDefinition;
        location: IconDefinition;
        location_on: IconDefinition;
        lock: IconDefinition;
        long_arrow_alt_left: IconDefinition;
        long_arrow_alt_right: IconDefinition;
        long_arrow_alt_up: IconDefinition;
        loyalty: IconDefinition;
        map_marked_alt: IconDefinition;
        map_marker_alt: IconDefinition;
        menu: IconDefinition;
        minus: IconDefinition;
        more_vert: IconDefinition;
        navigate_before: IconDefinition;
        navigate_next: IconDefinition;
        payment: IconDefinition;
        people_carry: IconDefinition;
        percent: IconDefinition;
        phone: IconDefinition;
        play_circle_regular: IconDefinition;
        playlist_add_check: IconDefinition;
        plug: IconDefinition;
        plus: IconDefinition;
        power_off: IconDefinition;
        print: IconDefinition;
        priority_high: IconDefinition;
        product: IconDefinition;
        question: IconDefinition;
        refresh: IconDefinition;
        remove: IconDefinition;
        retweet: IconDefinition;
        router: IconDefinition;
        save: IconDefinition;
        search: IconDefinition;
        shield_alt: IconDefinition;
        shipping_fast: IconDefinition;
        shopping_cart: IconDefinition;
        signIn: IconDefinition;
        smile_beam: IconDefinition;
        sms: IconDefinition;
        spa: IconDefinition;
        stop: IconDefinition;
        stop_circle: IconDefinition;
        sync: IconDefinition;
        tablet_alt: IconDefinition;
        tags: IconDefinition;
        taxi: IconDefinition;
        thumbs_up: IconDefinition;
        times_circle: IconDefinition;
        truck: IconDefinition;
        truck_moving: IconDefinition;
        undo: IconDefinition;
        unlock_alt: IconDefinition;
        user: IconDefinition;
        user_circle: IconDefinition;
        user_clock: IconDefinition;
        user_edit: IconDefinition;
        user_shield: IconDefinition;
        user_tie: IconDefinition;
        verified_user: IconDefinition;
        video: IconDefinition;
        warehouse: IconDefinition;
        warning: IconDefinition;
        widgets: IconDefinition;
        work: IconDefinition;
    };
    private static logger;
    snackbar: string;
    snackbarText: string;
    snackbarActionWrapper: string;
    snackbarActionButton: string;
    icons: string;
    card: string;
    cardActions: string;
    cardActionButtons: string;
    cardActionIcons: string;
    rippleSurface: string;
    private t;
    private uiIconFactory;
    private defaultUIFactory;
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {JSX.Element}
     */
    makeIcon(cfg: IUIIconConfiguration | string): JSX.Element;
    /**
     * @stable [30.09.2019]
     * @param {Error} e
     * @returns {Element}
     */
    makeWindowError(e: Error): Element;
    /**
     * @stable [02.12.2019]
     * @param {Error} e
     * @param {boolean} logging
     * @returns {React.ReactNode}
     */
    makeReactError(e: Error, logging?: boolean): React.ReactNode;
    /**
     * @stable [28.11.2019]
     * @param {IUniversalUiMessageConfigEntity} cfg
     * @returns {React.ReactNode}
     */
    makeMessage(cfg: IUniversalUiMessageConfigEntity): React.ReactNode;
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {IUIIconConfiguration}
     */
    private toIconConfig;
}
