"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a;
var React = require("react");
var inversify_1 = require("inversify");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
var free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../../util");
var di_1 = require("../../../di");
var definition_1 = require("../../../definition");
var UIMaterialFactory = /** @class */ (function () {
    function UIMaterialFactory() {
        this.snackbar = 'mdc-snackbar';
        this.snackbarText = 'mdc-snackbar__text';
        this.snackbarActionWrapper = 'mdc-snackbar__action-wrapper';
        this.snackbarActionButton = 'mdc-snackbar__action-button';
        this.icons = 'material-icons';
        this.card = 'mdc-card';
        this.cardActions = 'mdc-card__actions';
        this.cardActionButtons = 'mdc-card__action-buttons';
        this.cardActionIcons = 'mdc-card__action-icons';
        this.rippleSurface = 'mdc-ripple-surface';
    }
    UIMaterialFactory_1 = UIMaterialFactory;
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {JSX.Element}
     */
    UIMaterialFactory.prototype.makeIcon = function (cfg) {
        if (!cfg) {
            return null;
        }
        var config = this.toIconConfig(cfg);
        var uiIconCtor = this.uiIconFactory.makeInstance(config.type);
        var awIconCtor = UIMaterialFactory_1.ICONS_MAP[config.type];
        if (!awIconCtor && !uiIconCtor) {
            UIMaterialFactory_1.logger.warn("[$UIMaterialFactory] The icon " + config.type + " is not defined.");
        }
        var iconCtor = awIconCtor || free_solid_svg_icons_1.faQuestion;
        var hasHandler = util_1.isFn(config.onClick);
        return (React.createElement("div", __assign({ ref: config.ref, key: config.key, title: config.title, className: util_1.joinClassName('rac-icon', hasHandler && "rac-action-icon rac-action-" + config.type + "-icon", config.disabled && 'rac-disabled-icon', util_1.calc(config.className)) }, util_1.handlerPropsFactory(config.onClick, !config.disabled, util_1.nvl(config.touched, false))), uiIconCtor || React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: iconCtor })));
    };
    /**
     * @stable [30.09.2019]
     * @param {Error} e
     * @returns {Element}
     */
    UIMaterialFactory.prototype.makeWindowError = function (e) {
        return this.defaultUIFactory.makeWindowError(e);
    };
    /**
     * @stable [02.12.2019]
     * @param {Error} e
     * @param {boolean} logging
     * @returns {React.ReactNode}
     */
    UIMaterialFactory.prototype.makeReactError = function (e, logging) {
        return this.defaultUIFactory.makeReactError(e, logging);
    };
    /**
     * @stable [28.11.2019]
     * @param {IUniversalUiMessageConfigEntity} cfg
     * @returns {React.ReactNode}
     */
    UIMaterialFactory.prototype.makeMessage = function (cfg) {
        return this.defaultUIFactory.makeMessage(cfg);
    };
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {IUIIconConfiguration}
     */
    UIMaterialFactory.prototype.toIconConfig = function (cfg) {
        return (util_1.isString(cfg) ? { type: cfg } : cfg);
    };
    var UIMaterialFactory_1;
    UIMaterialFactory.ICONS_MAP = (_a = {},
        _a[definition_1.IconsEnum.SEARCH_MINUS] = free_solid_svg_icons_1.faSearchMinus,
        _a[definition_1.IconsEnum.SEARCH_PLUS] = free_solid_svg_icons_1.faSearchPlus,
        _a[definition_1.IconsEnum.SIGN_OUT_ALT] = free_solid_svg_icons_1.faSignOutAlt,
        _a.access_time = free_solid_svg_icons_1.faHistory,
        _a.add = free_solid_svg_icons_1.faPlus,
        _a.address_card = free_regular_svg_icons_1.faAddressCard,
        _a.adversal = free_brands_svg_icons_1.faAdversal,
        _a.angle_double_right = free_solid_svg_icons_1.faAngleDoubleRight,
        _a.angle_left = free_solid_svg_icons_1.faAngleLeft,
        _a.angle_right = free_solid_svg_icons_1.faAngleRight,
        _a.arrow_alt_circle_down = free_solid_svg_icons_1.faArrowAltCircleDown,
        _a.arrow_alt_circle_right_regular = free_regular_svg_icons_1.faArrowAltCircleRight,
        _a.arrow_alt_circle_up_regular = free_regular_svg_icons_1.faArrowAltCircleUp,
        _a.arrow_down = free_solid_svg_icons_1.faArrowDown,
        _a.arrow_left = free_solid_svg_icons_1.faArrowLeft,
        _a.arrow_right = free_solid_svg_icons_1.faArrowRight,
        _a.arrow_up = free_solid_svg_icons_1.faArrowUp,
        _a.attach_file = free_solid_svg_icons_1.faPaperclip,
        _a.attention = free_solid_svg_icons_1.faExclamationCircle,
        _a.barcode = free_solid_svg_icons_1.faBarcode,
        _a.binoculars = free_solid_svg_icons_1.faBinoculars,
        _a.card_giftcard = free_solid_svg_icons_1.faGift,
        _a.category = free_brands_svg_icons_1.faCodepen,
        _a.chart_pie = free_solid_svg_icons_1.faChartPie,
        _a.check = free_solid_svg_icons_1.faCheck,
        _a.check_circle = free_solid_svg_icons_1.faCheckCircle,
        _a.circle_regular = free_regular_svg_icons_1.faCircle,
        _a.clear_all = free_solid_svg_icons_1.faEraser,
        _a.cloud = free_solid_svg_icons_1.faCloud,
        _a.comments_regular = free_regular_svg_icons_1.faComments,
        _a.contact_mail = free_regular_svg_icons_1.faEnvelope,
        _a.contact_phone = free_solid_svg_icons_1.faPhone,
        _a.dashboard = free_solid_svg_icons_1.faChartLine,
        _a.done = free_solid_svg_icons_1.faCheck,
        _a.done_all = free_solid_svg_icons_1.faCheckDouble,
        _a.error = free_solid_svg_icons_1.faExclamationCircle,
        _a.exchange = free_solid_svg_icons_1.faExchangeAlt,
        _a.exchange_alt = free_solid_svg_icons_1.faExchangeAlt,
        _a.exclamation = free_solid_svg_icons_1.faExclamation,
        _a.exclamation_circle = free_solid_svg_icons_1.faExclamationCircle,
        _a.exclamation_triangle = free_solid_svg_icons_1.faExclamationTriangle,
        _a.eye = free_solid_svg_icons_1.faEye,
        _a.fa_heart_regular = free_regular_svg_icons_1.faHeart,
        _a.file = free_regular_svg_icons_1.faFileAlt,
        _a.file_import = free_solid_svg_icons_1.faFileImport,
        _a.file_invoice_dollar = free_solid_svg_icons_1.faFileInvoiceDollar,
        _a.first_page = free_solid_svg_icons_1.faAngleDoubleLeft,
        _a.gift = free_solid_svg_icons_1.faGift,
        _a.grip_horizontal = free_solid_svg_icons_1.faGripHorizontal,
        _a.group = free_solid_svg_icons_1.faUsers,
        _a.hdd = free_regular_svg_icons_1.faHdd,
        _a.history = free_solid_svg_icons_1.faHistory,
        _a.home = free_solid_svg_icons_1.faHome,
        _a.houzz = free_brands_svg_icons_1.faHouzz,
        _a.http = free_solid_svg_icons_1.faExchangeAlt,
        _a.id_card = free_regular_svg_icons_1.faIdCard,
        _a.info = free_solid_svg_icons_1.faInfo,
        _a.key = free_solid_svg_icons_1.faKey,
        _a.local_atm = free_solid_svg_icons_1.faMoneyBill,
        _a.local_offer = free_solid_svg_icons_1.faTag,
        _a.location = free_solid_svg_icons_1.faMapMarkerAlt,
        _a.location_on = free_solid_svg_icons_1.faMapMarkerAlt,
        _a.lock = free_solid_svg_icons_1.faLock,
        _a.long_arrow_alt_left = free_solid_svg_icons_1.faLongArrowAltLeft,
        _a.long_arrow_alt_right = free_solid_svg_icons_1.faLongArrowAltRight,
        _a.long_arrow_alt_up = free_solid_svg_icons_1.faLongArrowAltUp,
        _a.loyalty = free_brands_svg_icons_1.faGratipay,
        _a.map_marked_alt = free_solid_svg_icons_1.faMapMarkedAlt,
        _a.map_marker_alt = free_solid_svg_icons_1.faMapMarkerAlt,
        _a.menu = free_solid_svg_icons_1.faBars,
        _a.minus = free_solid_svg_icons_1.faMinus,
        _a.more_vert = free_solid_svg_icons_1.faEllipsisV,
        _a.navigate_before = free_solid_svg_icons_1.faChevronLeft,
        _a.navigate_next = free_solid_svg_icons_1.faChevronRight,
        _a.payment = free_regular_svg_icons_1.faCreditCard,
        _a.people_carry = free_solid_svg_icons_1.faPeopleCarry,
        _a.percent = free_solid_svg_icons_1.faPercent,
        _a.phone = free_solid_svg_icons_1.faPhone,
        _a.play_circle_regular = free_regular_svg_icons_1.faPlayCircle,
        _a.playlist_add_check = free_solid_svg_icons_1.faClipboardCheck,
        _a.plug = free_solid_svg_icons_1.faPlug,
        _a.plus = free_solid_svg_icons_1.faPlus,
        _a.power_off = free_solid_svg_icons_1.faPowerOff,
        _a.print = free_solid_svg_icons_1.faPrint,
        _a.priority_high = free_solid_svg_icons_1.faExclamation,
        _a.product = free_solid_svg_icons_1.faCannabis,
        _a.question = free_solid_svg_icons_1.faQuestion,
        _a.refresh = free_solid_svg_icons_1.faSync,
        _a.remove = free_solid_svg_icons_1.faMinus,
        _a.retweet = free_solid_svg_icons_1.faRetweet,
        _a.router = free_solid_svg_icons_1.faServer,
        _a.save = free_regular_svg_icons_1.faSave,
        _a.search = free_solid_svg_icons_1.faSearch,
        _a.shield_alt = free_solid_svg_icons_1.faShieldAlt,
        _a.shipping_fast = free_solid_svg_icons_1.faShippingFast,
        _a.shopping_cart = free_solid_svg_icons_1.faShoppingCart,
        _a.signIn = free_solid_svg_icons_1.faSignInAlt,
        _a.smile_beam = free_regular_svg_icons_1.faSmileBeam,
        _a.sms = free_solid_svg_icons_1.faCommentDots,
        _a.spa = free_solid_svg_icons_1.faCannabis,
        _a.stop = free_solid_svg_icons_1.faStop,
        _a.stop_circle = free_regular_svg_icons_1.faStopCircle,
        _a.sync = free_solid_svg_icons_1.faSync,
        _a.tablet_alt = free_solid_svg_icons_1.faTabletAlt,
        _a.tags = free_solid_svg_icons_1.faTags,
        _a.taxi = free_solid_svg_icons_1.faTaxi,
        _a.thumbs_up = free_regular_svg_icons_1.faThumbsUp,
        _a.times_circle = free_solid_svg_icons_1.faTimesCircle,
        _a.truck = free_solid_svg_icons_1.faTruck,
        _a.truck_moving = free_solid_svg_icons_1.faTruckMoving,
        _a.undo = free_solid_svg_icons_1.faUndo,
        _a.unlock_alt = free_solid_svg_icons_1.faUnlockAlt,
        _a.user = free_regular_svg_icons_1.faUser,
        _a.user_circle = free_regular_svg_icons_1.faUserCircle,
        _a.user_clock = free_solid_svg_icons_1.faUserClock,
        _a.user_edit = free_solid_svg_icons_1.faUserEdit,
        _a.user_shield = free_solid_svg_icons_1.faUserShield,
        _a.user_tie = free_solid_svg_icons_1.faUserTie,
        _a.verified_user = free_solid_svg_icons_1.faShieldAlt,
        _a.video = free_solid_svg_icons_1.faVideo,
        _a.warehouse = free_solid_svg_icons_1.faWarehouse,
        _a.warning = free_solid_svg_icons_1.faExclamationTriangle,
        _a.widgets = free_solid_svg_icons_1.faCubes,
        _a.work = free_solid_svg_icons_1.faBriefcase,
        _a);
    UIMaterialFactory.logger = ts_smart_logger_1.LoggerFactory.makeLogger('UIMaterialFactory');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Translate),
        __metadata("design:type", Function)
    ], UIMaterialFactory.prototype, "t", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.UiIconFactory),
        __metadata("design:type", Object)
    ], UIMaterialFactory.prototype, "uiIconFactory", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.UIDefaultFactory),
        __metadata("design:type", Object)
    ], UIMaterialFactory.prototype, "defaultUIFactory", void 0);
    UIMaterialFactory = UIMaterialFactory_1 = __decorate([
        inversify_1.injectable()
    ], UIMaterialFactory);
    return UIMaterialFactory;
}());
exports.UIMaterialFactory = UIMaterialFactory;
//# sourceMappingURL=ui-material.factory.js.map