/// <reference types="react" />
import { BaseComponent } from '../base/base.component';
import { IMenu, IMenuProps, IMenuState } from '../../definition';
export declare class Menu extends BaseComponent<IMenuProps, IMenuState> implements IMenu {
    static readonly defaultProps: IMenuProps;
    private readonly dialogRef;
    private readonly listRef;
    private readonly fieldRef;
    private filterQueryTask;
    private scrollEventUnsubscriber;
    private resizeUnsubscriber;
    /**
     * @stable [24.01.2020]
     * @param {IMenuProps} props
     */
    constructor(props: IMenuProps);
    /**
     * @stable [24.01.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [18.06.2019]
     */
    componentWillUnmount(): void;
    /**
     * @stable [31.01.2020]
     * @param {() => void} callback
     */
    show(callback?: () => void): void;
    /**
     * @stable [18.06.2019]
     */
    hide(): void;
    /**
     * @stable [29.11.2018]
     * @returns {boolean}
     */
    isOpen(): boolean;
    /**
     * @stable [23.11.2019]
     */
    private notifyFilterChange;
    /**
     * @stable [24.01.2020]
     * @param {string} filter
     */
    private onFilterValueChange;
    /**
     * @stable [23.11.2019]
     * @param {IMenuItemEntity} option
     */
    private onSelect;
    /**
     * @stable [06.01.2020]
     */
    private onDialogDeactivate;
    /**
     * @stable [25.01.2020]
     */
    private onDialogActivate;
    /**
     * @stable [25.01.2020]
     */
    private onDialogAfterRender;
    /**
     * @stable [25.01.2020]
     */
    private onDialogAfterDestroy;
    /**
     * @stable [24.01.2020]
     * @returns {JSX.Element}
     */
    private readonly listElement;
    /**
     * @stable [29.01.2020]
     * @param {IMenuItemEntity} option
     * @param {number} index
     * @param {number} length
     * @returns {JSX.Element}
     */
    private asItemElement;
    /**
     * @stable [17.01.2020]
     * @returns {JSX.Element}
     */
    private readonly filterElement;
    /**
     * @stable [06.07.2019]
     * @returns {JSX.Element}
     */
    private readonly closeActionElement;
    /**
     * @stable [17.01.2020]
     * @param {HTMLElement} element
     * @returns {boolean}
     */
    private scrollEventCallbackCondition;
    /**
     * @stable [24.01.2020]
     */
    private clearAll;
    /**
     * @stable [23.11.2019]
     */
    private unsubscribeAllEvents;
    /**
     * @stable [24.01.2020]
     * @returns {boolean}
     */
    private readonly isAnchored;
    /**
     * @stable [23.11.2019]
     * @returns {boolean}
     */
    private readonly isFilterUsed;
    /**
     * @stable [23.11.2019]
     * @returns {IMenuItemEntity[]}
     */
    private readonly items;
    /**
     * @stable [07.06.2018]
     * @returns {TextField}
     */
    private readonly field;
    /**
     * @stable [17.06.2019]
     * @returns {Dialog}
     */
    private readonly dialog;
    /**
     * @stable [17.06.2019]
     * @param {IMenuItemEntity} itm
     * @returns {StringNumberT}
     */
    private readonly optionValueFn;
}
