import { Store } from 'redux';
import { IEffectsAction } from 'redux-effects-promise';
import { IDispatcher, IUniversalContainerProps, IUniversalStoreEntity } from '../../../definition';
import { IKeyValue, IPropsWrapper } from '../../../definitions.interface';
export declare class BaseStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> implements IDispatcher {
    protected readonly container: IPropsWrapper<TProps>;
    protected readonly appStore: Store<TStore>;
    /**
     * @stable [24.03.2020]
     * @param {{props: TProps}} container
     */
    constructor(container: IPropsWrapper<TProps>);
    /**
     * @stable [03.10.2019]
     * @param {string} type
     * @param {TChanges} data
     */
    dispatch<TChanges = IKeyValue>(type: string, data?: TChanges): void;
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TData} data
     */
    dispatchCustomType<TData = IKeyValue>(type: string, data?: TData): void;
    /**
     * @stable [24.03.2020]
     * @param {IEffectsAction} action
     */
    dispatchAnyAction(action: IEffectsAction): void;
    /**
     * @stable [11.09.2019]
     * @returns {string}
     */
    protected readonly sectionName: string;
    /**
     * @stable [11.09.2019]
     * @returns {TProps}
     */
    protected readonly props: TProps;
}
