"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../../util");
var di_1 = require("../../../di");
var BaseStoreProxy = /** @class */ (function () {
    /**
     * @stable [24.03.2020]
     * @param {{props: TProps}} container
     */
    function BaseStoreProxy(container) {
        this.container = container;
    }
    /**
     * @stable [03.10.2019]
     * @param {string} type
     * @param {TChanges} data
     */
    BaseStoreProxy.prototype.dispatch = function (type, data) {
        this.dispatchCustomType(this.sectionName + "." + type, util_1.applySection(this.sectionName, data));
    };
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TData} data
     */
    BaseStoreProxy.prototype.dispatchCustomType = function (type, data) {
        this.dispatchAnyAction({ type: type, data: data });
    };
    /**
     * @stable [24.03.2020]
     * @param {IEffectsAction} action
     */
    BaseStoreProxy.prototype.dispatchAnyAction = function (action) {
        this.appStore.dispatch(action);
    };
    Object.defineProperty(BaseStoreProxy.prototype, "sectionName", {
        /**
         * @stable [11.09.2019]
         * @returns {string}
         */
        get: function () {
            return this.props.sectionName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseStoreProxy.prototype, "props", {
        /**
         * @stable [11.09.2019]
         * @returns {TProps}
         */
        get: function () {
            return this.container.props;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], BaseStoreProxy.prototype, "appStore", void 0);
    return BaseStoreProxy;
}());
exports.BaseStoreProxy = BaseStoreProxy;
//# sourceMappingURL=base-store.proxy.js.map