import * as React from 'react';
import { BaseStoreProxy } from '../base-store.proxy';
import { IDialog, IDialogFormChangesConfirmStoreProxy, IRouterStoreProxyFactoryConfigEntity, IUniversalContainerProps, IUniversalStoreEntity } from '../../../../definition';
import { IPropsWrapper } from '../../../../definitions.interface';
export declare class DialogFormChangesConfirmStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> extends BaseStoreProxy<TStore, TProps> implements IDialogFormChangesConfirmStoreProxy {
    readonly container: IPropsWrapper<TProps>;
    private readonly routerStoreProxyFactory;
    private readonly dialogRef;
    private readonly routerStoreProxy;
    private readonly originalGoBackFn;
    private $cachedDepth;
    /**
     * @stable [09.10.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    constructor(container: IPropsWrapper<TProps>);
    /**
     * @stable [20.12.2019]
     * @param {(cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element} factory
     * @returns {React.ReactNode[]}
     */
    buildNavigationSteps(factory: (cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element): React.ReactNode[];
    /**
     * @stable [03.10.2019]
     */
    activateDialog(): void;
    /**
     * @stable [18.12.2019]
     */
    goBack(): void;
    /**
     * @stable [03.10.2019]
     * @returns {React.RefObject<T extends IDialog>}
     */
    getDialogRef<T extends IDialog>(): React.RefObject<T>;
    /**
     * @stable [23.12.2019]
     * @param {number} depth
     */
    private interceptGoBack;
}
