import { BaseStoreProxy } from '../base-store.proxy';
import { IDictionaryStoreProxy, IUniversalContainerProps, IUniversalStoreEntity } from '../../../../definition';
import { IKeyValue, IPropsWrapper } from '../../../../definitions.interface';
export declare class DictionaryStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> extends BaseStoreProxy<TStore, TProps> implements IDictionaryStoreProxy {
    readonly container: IPropsWrapper<TProps>;
    /**
     * @stable [24.03.2020]
     * @param {IPropsWrapper<TProps extends IUniversalContainerProps>} container
     */
    constructor(container: IPropsWrapper<TProps>);
    /**
     * @stable [11.01.2020]
     * @param {string} dictionary
     * @param {TData} data
     */
    dispatchLoadDictionary<TData = IKeyValue>(dictionary: string, data?: TData): void;
}
