import * as React from 'react';
import { BaseStoreProxy } from '../base-store.proxy';
import { IRouterStoreProxy, IRouterStoreProxyFactoryConfigEntity, IUniversalContainerProps, IUniversalStoreEntity } from '../../../../definition';
import { IPropsWrapper } from '../../../../definitions.interface';
export declare class RouterStoreProxy<TStore extends IUniversalStoreEntity = IUniversalStoreEntity, TProps extends IUniversalContainerProps = IUniversalContainerProps> extends BaseStoreProxy<TStore, TProps> implements IRouterStoreProxy {
    readonly container: IPropsWrapper<TProps>;
    /**
     * @stable [24.03.2020]
     * @param {IPropsWrapper<TProps extends IUniversalContainerProps>} container
     */
    constructor(container: IPropsWrapper<TProps>);
    /**
     * @stable [06.02.2020]
     * @param {string} path
     */
    navigate(path: string): void;
    /**
     * @stable [20.12.2019]
     * @param {number} depth
     */
    goBack(depth?: number): void;
    /**
     * @stable [20.12.2019]
     */
    navigateBack(): void;
    /**
     * @stable [19.12.2019]
     * @param {(cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element} factory
     * @returns {React.ReactNode[]}
     */
    buildNavigationSteps(factory: (cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element): React.ReactNode[];
}
