/// <reference types="react" />
import { BaseContainer } from '../base';
import { IActiveValueWrapper, IPayloadWrapper } from '../../definitions.interface';
import { ITabPanelContainerProps } from '../../definition';
export declare class TabPanelContainer<TProps extends ITabPanelContainerProps = ITabPanelContainerProps> extends BaseContainer<TProps> {
    /**
     * @stable [30.08.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [30.08.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [12.02.2020]
     * @returns {IActiveValueWrapper}
     */
    protected getActiveValueWrapper(): IActiveValueWrapper;
    /**
     * @stable [30.08.2018]
     * @param {IPayloadWrapper<number>} payloadWrapper
     */
    protected dispatchActiveValue(payloadWrapper: IPayloadWrapper<number>): void;
    /**
     * @stable [30.08.2018]
     * @param {IPayloadWrapper<number>} payloadWrapper
     */
    protected dispatchDeactivatedValue(payloadWrapper: IPayloadWrapper<number>): void;
    /**
     * @stable [30.08.2018]
     * @param {IGenericTabEntity} tab
     */
    private onTabClick;
    /**
     * @stable [02.09.2018]
     * @param {number} activeValue
     */
    private onDeactivate;
}
