import { AnyT } from '../definitions.interface';
import { IStorage } from '../definition';
export declare abstract class BaseStorage implements IStorage {
    protected prefix: string;
    /**
     * @stable [29.07.2019]
     * @param {string} prefix
     */
    protected constructor(prefix: string);
    /**
     * @stable [29.07.2019]
     * @param {string} key
     * @param {AnyT} value
     * @returns {Promise<boolean>}
     */
    abstract set(key: string, value: AnyT): Promise<boolean>;
    /**
     * @stable [13.03.2020]
     * @param {string} key
     * @param {boolean} noPrefix
     * @returns {string}
     */
    protected toKey(key: string, noPrefix?: boolean): string;
}
