"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../util");
var action_1 = require("../../action");
/**
 * @stable [26.03.2020]
 * @param {IChainedMiddlewareConfigEntity<TState, TPayload>} config
 * @returns {IEffectsAction[]}
 */
exports.makeChainedMiddleware = function (config) {
    return util_1.$areEffectsPrevented(util_1.selectPreventEffectsFromAction(config.action))
        ? []
        : ([
            action_1.StackActionBuilder.buildLockAction(util_1.isFn(config.nextSection)
                ? config.nextSection(config.payload, config.state, config.action)
                : config.nextSection),
            action_1.RouterActionBuilder.buildNavigateAction(util_1.isFn(config.path)
                ? config.path(config.payload, config.state, config.action)
                : config.path)
        ]);
};
//# sourceMappingURL=chained.middleware.js.map