"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var action_builder_1 = require("../../component/action.builder");
var configurations_definitions_interface_1 = require("../../configurations-definitions.interface");
/**
 * @stable [13.09.2018]
 * @param {IRefreshedListMiddlewareConfig} config
 * @returns {IEffectsAction[]}
 */
exports.makeRefreshedListMiddleware = function (config) {
    var payloadWrapper = config.action.data;
    switch (payloadWrapper.payload) {
        case configurations_definitions_interface_1.ToolbarActionEnum.REFRESH_DATA:
            return [action_builder_1.ListActionBuilder.buildLoadAction(config.listSection)];
    }
    return null;
};
//# sourceMappingURL=refreshed-list.middleware.js.map