"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../util");
var action_builder_1 = require("../../component/action.builder");
var default_form_changes_middleware_1 = require("./default-form-changes.middleware");
/**
 * @stable [27.03.2020]
 * @param {IUntouchedListMiddlewareConfigEntity<TState>} config
 * @returns {(action: IEffectsAction, state: TState) => IEffectsAction}
 */
exports.makeUntouchedListMiddleware = function (config) {
    return function (action, state) {
        return util_1.ifNotEmptyThanValue(util_1.notNilValuesArrayFilter(default_form_changes_middleware_1.makeDefaultFormChangesMiddleware(config), util_1.orNull(!util_1.isTouched(config.listAccessor(state)), function () { return action_builder_1.ListActionBuilder.buildLoadAction(config.listSection); })), function (actions) { return actions; });
    };
};
//# sourceMappingURL=untouched-list.middleware.js.map