"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var definition_1 = require("../definition");
var transport_reducer_interface_1 = require("./transport-reducer.interface");
var util_1 = require("../util");
function transportReducer(state, action) {
    if (state === void 0) { state = definition_1.INITIAL_TRANSPORT_ENTITY; }
    var payloadData = util_1.selectData(action);
    var operationId = util_1.ifNotNilThanValue(payloadData, function (data) { return data.operationId; });
    switch (action.type) {
        case transport_reducer_interface_1.$RAC_TRANSPORT_REQUEST_ACTION_TYPE:
            return __assign({}, state, { queue: operationId
                    ? state.queue.concat(operationId)
                    : state.queue });
        case transport_reducer_interface_1.TRANSPORT_REQUEST_CANCEL_ACTION_TYPE:
        case transport_reducer_interface_1.TRANSPORT_REQUEST_ERROR_ACTION_TYPE:
        case transport_reducer_interface_1.$RAC_TRANSPORT_REQUEST_DONE_ACTION_TYPE:
            return __assign({}, state, { queue: operationId
                    ? state.queue.filter(function (item) { return item !== operationId; })
                    : state.queue });
        case transport_reducer_interface_1.TRANSPORT_DESTROY_ACTION_TYPE: {
            return __assign({}, definition_1.INITIAL_TRANSPORT_ENTITY);
        }
        case definition_1.$_RAC_TRANSPORT_UPDATE_TOKEN_ACTION_TYPE:
            return __assign({}, state, { token: payloadData.token });
        case definition_1.$_RAC_TRANSPORT_DESTROY_TOKEN_ACTION_TYPE:
            return __assign({}, state, { token: null });
    }
    return state;
}
exports.transportReducer = transportReducer;
//# sourceMappingURL=transport.reducer.js.map