import { IUserActivityConfigEntity, IUserActivityManager } from '../../definition';
export declare class UserActivityManager implements IUserActivityManager {
    private static readonly logger;
    private readonly domAccessor;
    private readonly environment;
    private suspended;
    private inactivityTask;
    private keyPressEventUnsubscriber;
    private mouseDownEventUnsubscriber;
    private mouseMoveEventUnsubscriber;
    private touchMoveEventUnsubscriber;
    private touchStartEventUnsubscriber;
    /**
     * @stable [19.01.2020]
     */
    constructor();
    /**
     * @stable [19.01.2020]
     * @param {IUserActivityConfigEntity} cfg
     */
    spy(cfg: IUserActivityConfigEntity): void;
    /**
     * @stable [19.01.2020]
     */
    suspend(): void;
    /**
     * @stable [19.01.2020]
     */
    resume(): void;
    /**
     * @stable [19.01.2020]
     */
    cancel(): void;
    /**
     * @stable [19.01.2020]
     * @param {() => void} callback
     */
    private onUserDeactivate;
    /**
     * @stable [19.01.2020]
     */
    private onUserActivate;
}
