"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var definitions_interface_1 = require("../definitions.interface");
var cond_1 = require("./cond");
var util_1 = require("../util");
var object_1 = require("./object");
/**
 * @stable [05.08.2018]
 * @param {AnyT} v
 * @returns {AnyT}
 */
exports.undefEmpty = function (v) { return object_1.isObjectNotEmpty(v) ? v : definitions_interface_1.UNDEF; };
/**
 * @stable [05.08.2018]
 * @param {AnyT} v
 * @returns {AnyT}
 */
exports.trimmedUndefEmpty = function (v) { return cond_1.ifNotNilThanValue(exports.undefEmpty(v), function (result) { return String(result).trim(); }, definitions_interface_1.UNDEF_SYMBOL); };
/**
 * @stable [05.08.2018]
 * @param {AnyT} v1
 * @param {AnyT} v2
 * @returns {AnyT}
 */
exports.nvl = function (v1, v2) { return R.isNil(v1) ? v2 : v1; };
/**
 * @stable [31.08.2018]
 * @param {TValue} v
 * @returns {TValue}
 */
exports.coalesce = function () {
    var v = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        v[_i] = arguments[_i];
    }
    return R.find(function (v0) { return !R.isNil(v0); }, v);
};
/**
 * @stable [13.06.2019]
 * @param {TValue} v
 * @returns {TValue}
 */
exports.coalesceDef = function () {
    var v = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        v[_i] = arguments[_i];
    }
    return R.find(function (v0) { return util_1.isDef(v0); }, v);
};
//# sourceMappingURL=nvl.js.map