"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var definitions_interface_1 = require("../definitions.interface");
var type_1 = require("./type");
/**
 * @stable [19.12.2018]
 * @param {AnyT} o
 * @returns {boolean}
 */
exports.isObjectNotEmpty = function (o) { return !R.isNil(o) && !R.isEmpty(o); };
/**
 * @stable [18.03.2020]
 * @param {AnyT} o
 * @returns {boolean}
 */
exports.isStringNotEmpty = function (o) { return type_1.isString(o) && exports.isObjectNotEmpty(o); };
/**
 * @stable [20.03.2019]
 * @param {AnyT} current
 * @param {AnyT} previous
 * @returns {boolean}
 */
exports.isCurrentValueNotEqualPreviousValue = function (current, previous) {
    return exports.isObjectNotEmpty(current) && !R.equals(current, previous);
};
/**
 * @stable [25.11.2019]
 * @param {TValue} object
 * @returns {TValue}
 */
exports.buildUndefValuesObject = function (object) {
    return R.isNil(object)
        ? object
        : R.mergeAll(Object.keys(object).map(function (key) {
            var _a;
            return (_a = {}, _a[key] = definitions_interface_1.UNDEF, _a);
        }));
};
//# sourceMappingURL=object.js.map