import * as React from 'react';
import { IBaseEvent } from '../definition';
import { IKeyValue } from '../definitions.interface';
/**
 * @stable [24.03.2020]
 * @param {TProps} props
 * @param {TProps} systemProps
 * @returns {TProps}
 */
export declare const mergeWithSystemProps: <TProps = IKeyValue>(props: TProps, systemProps: TProps) => TProps;
/**
 * @stable [22.10.2019]
 * @param {(e?: IBaseEvent) => void} handler
 * @param {boolean} canAttachHandler
 * @param {boolean} touched
 * @returns {Partial<React.DetailedHTMLProps<React.HTMLAttributes<TElement extends HTMLElement>, TElement extends HTMLElement>>}
 */
export declare const handlerPropsFactory: <TElement extends HTMLElement>(handler: (e?: IBaseEvent) => void, canAttachHandler?: boolean, touched?: boolean) => Partial<React.DetailedHTMLProps<React.HTMLAttributes<TElement>, TElement>>;
