"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var event_1 = require("./event");
var di_services_1 = require("../di/di.services");
var cond_1 = require("./cond");
var type_1 = require("./type");
/**
 * @stable [24.03.2020]
 * @param {TProps} props
 * @param {TProps} systemProps
 * @returns {TProps}
 */
exports.mergeWithSystemProps = function (props, systemProps) {
    return R.isNil(systemProps)
        ? props
        : __assign({}, props, systemProps);
};
/**
 * @stable [22.10.2019]
 * @param {(e?: IBaseEvent) => void} handler
 * @param {boolean} canAttachHandler
 * @param {boolean} touched
 * @returns {Partial<React.DetailedHTMLProps<React.HTMLAttributes<TElement extends HTMLElement>, TElement extends HTMLElement>>}
 */
exports.handlerPropsFactory = function (handler, canAttachHandler, touched) {
    if (canAttachHandler === void 0) { canAttachHandler = true; }
    if (touched === void 0) { touched = true; }
    return (__assign({}, cond_1.ifNotFalseThanValue(canAttachHandler === true && type_1.isFn(handler) && (touched === true && di_services_1.getEnvironment().mobilePlatform), function () { return ({
        onClick: event_1.cancelEvent,
        onDoubleClick: event_1.cancelEvent,
        onTouchStart: function (e) {
            event_1.cancelEvent(e, true);
            handler(e);
        },
    }); }), cond_1.ifNotFalseThanValue(canAttachHandler === true && type_1.isFn(handler) && (touched === false || !di_services_1.getEnvironment().mobilePlatform), function () { return ({
        onClick: function (e) {
            event_1.cancelEvent(e);
            handler(e);
        },
    }); })));
};
//# sourceMappingURL=props.js.map